#include <set>
#include <ctime>
#include <cstdio>
#include <vector>
#include <cstring>
#include <algorithm>
using namespace std;

const int COMPLEXITY = 10000000;
const int MAXN = 155;
const int MAXM = 505;

int h , w;
int n , m;
pair < int , int > b[MAXM];
vector < int > a[MAXN];

pair < int , int > c[MAXN];
set < pair < int , int > > st;

int t[MAXN][MAXN];
pair < int , int > best[MAXN];
int cnt[MAXN];

void read() {
	int i;
	
	scanf ( "%d%d" , &h , &w );
	scanf ( "%d%d" , &n , &m );
	
	for (i = 1; i <= m; i++) {
		scanf ( "%d%d" , &b[i].first , &b[i].second );
		
		a[ b[i].first ].push_back ( b[i].second );
		a[ b[i].second ].push_back ( b[i].first );
	}
}

long long cross ( pair < int , int > a , pair < int , int > b , pair < int , int > c ) {
	return (long long)(b.first - a.first) * (long long)(c.second - a.second)
			-
		   (long long)(c.first - a.first) * (long long)(b.second - a.second);
}

int intersect ( pair < int , int > x1 , pair < int , int > y1 , pair < int , int > x2 , pair < int , int > y2 ) {
	long long q , w , e , r;
	
	q = cross ( x1 , x2 , y1 );
	w = cross ( x2 , y1 , y2 );
	e = cross ( y1 , y2 , x1 );
	r = cross ( y2 , x1 , x2 );
	
	if ( q == 0 && w == 0 && e == 0 && r == 0 ) {
		if ( min ( x1.first , y1.first ) < max ( x2.first , y2.first )
			&& min ( x2.first , y2.first ) < max ( x1.first , y1.first ) )
			return 1;
	}
	
	if ( q >= 0 && w >= 0 && e >= 0 && r >= 0 )
		return 1;
	
	if ( q <= 0 && w <= 0 && e <= 0 && r <= 0 )
		return 1;
	
	return 0;
}

int common_point ( pair < int , int > x1 , pair < int , int > y1 , pair < int , int > x2 , pair < int , int > y2 ) {
	long long q , w , e , r;
	
	q = cross ( x1 , x2 , y1 );
	w = cross ( x2 , y1 , y2 );
	e = cross ( y1 , y2 , x1 );
	r = cross ( y2 , x1 , x2 );
	
	if ( q == 0 && w == 0 && e == 0 && r == 0 ) {
		if ( min ( x1.first , y1.first ) < max ( x2.first , y2.first )
			&& min ( x2.first , y2.first ) < max ( x1.first , y1.first ) )
			return 1;
	}
	
	return 0;
}

void solve() {
	double tim = clock();
	int i , j , k;
	int q , e;
	int bad;
	int ans = 1 << 30 , cur;
	int iter = 0;
	
	do {
		st.clear();
		
		for (i = 1; i <= n; i++) {
			do {
				if ( rand() % 100 <= 95 ) {
					q = best[i].first;
					e = best[i].second;
				} else {
					q = rand() % (h + 1);
					e = rand() % (w + 1);
				}
			} while ( st.count ( make_pair ( q , e ) ) );
			
			st.insert ( make_pair ( q , e ) );
			c[i] = make_pair ( q , e );	
		}
		
		bad = 0;
		cur = 0;
		
		for (i = 1; i <= m && !bad; i++) 
			for (j = i + 1; j <= m && !bad; j++) {
				if ( ((b[i].first + b[i].second) & 1) != ((b[j].first + b[j].second) & 1) ) continue;
				if ( common_point ( c[ b[i].first ] , c[ b[i].second ] , c[ b[j].first ] , c[ b[j].second ] ) ) 
					bad = 1;
			
				if ( b[i].first == b[j].first || b[i].first == b[j].second ) continue;
				if ( b[i].second == b[j].first || b[i].second == b[j].second ) continue;
				
				
				if ( intersect ( c[ b[i].first ] , c[ b[i].second ] , c[ b[j].first ] , c[ b[j].second ] ) ) 
					++ cur;
			}
			
		if ( !bad && cur < ans ) {
			ans = cur;
			for (i = 1; i <= n; i++)
				best[i] = c[i];
		}
		
		++ iter;
	} while ( ((double)clock() - tim) / (double)CLOCKS_PER_SEC < 17 );
	
	memset ( cnt , 0 , sizeof cnt );
	for (i = 1; i <= n; i++)
		c[i] = best[i];
	cur = ans;
	
	for (i = 1; i <= n; i++) {
		for (j = 0; j < (int)a[i].size(); j++) {
			t[i][j] = 0;
			
			for (k = 1; k <= m; k++) {
				if ( ((i + a[i][j]) & 1) != ((b[k].first + b[k].second) & 1) ) continue;
				if ( i != b[k].first && i == b[k].second && a[i][j] != b[k].first && a[i][j] != b[k].second ) {
					if ( intersect ( c[i] , c[ a[i][j] ] , c[ b[k].first ] , c[ b[k].second ] ) ) {
						t[i][j] ++;
					}
				}
			}
			
			cnt[i] += t[i][j];
		}
	}
	
// 	fprintf ( stderr , " -- %d\n" , cur );
	/*
	do {
		int idx = 1;
		int val = cnt[1];
		
		for (i = 2; i <= n; i++)
			if ( cnt[i] > val ) {
				val = cnt[i];
				idx = i;
			}
			
		st.erase ( make_pair ( c[idx].first , c[idx].second ) );
			
		do {
			q = rand() % (h + 1);
			e = rand() % (w + 1);
		} while ( st.count ( make_pair ( q , e ) ) );
		
		st.insert ( make_pair ( q , e ) );
		c[idx] = make_pair ( q , e );
		
		for (i = 0; i < (int)a[idx].size(); i++) {
			cnt[idx] -= t[idx][i];
			cur -= t[idx][i];
			
			t[idx][i] = 0;
			
			for (k = 1; k <= m; k++) {
				if ( ((idx + a[idx][i]) & 1) != ((b[k].first + b[k].second) & 1) ) continue;
				
				if ( idx != b[k].first && idx != b[k].second 
										&& a[idx][i] != b[k].first && a[idx][i] != b[k].second ) {
					if ( intersect ( c[idx] , c[ a[idx][i] ] , c[ b[k].first ] , c[ b[k].second ] ) ) {
						cnt[idx] ++;
					}
				}
			}
			
			cnt[idx] += t[idx][i];
			cur += t[idx][i];
		}
	} while ( ((double)clock() - tim) / (double)CLOCKS_PER_SEC < 17 );
	*/
// 	fprintf ( stderr , "%d\n" , cur );
	for (i = 1; i <= m; i++) {
		printf ( "%d %d %d 2 %d %d %d %d\n" , b[i].first , b[i].second , (b[i].first + b[i].second) & 1 ,
														c[ b[i].first ].first , c[ b[i].first ].second ,
														c[ b[i].second ].first , c[ b[i].second ].second );
	}
}

int main() {
#ifndef HOME
	freopen ( "circuit.in" , "r" , stdin );
	freopen ( "circuit.out" , "w" , stdout );
#endif

	read();
	solve();
	
	return 0;
}
